package edujin.repository;

import edujin.model.Article;
import edujin.util.HibernateUtil;
import org.hibernate.Session;
import org.hibernate.Transaction;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import java.util.List;

public class ArticleRepository extends BaseRepository   {
    private static ArticleRepository instance = null;
    private ArticleRepository() {
        super();

    }
    public static ArticleRepository getInstance() {
        if (instance == null) {
            instance = new ArticleRepository();
        }
        return instance;
    }

    public String countArticle() {
        Transaction tx = null;
        Session session = HibernateUtil.getSessionFactory().getCurrentSession();
        try {
            tx = session.beginTransaction();
            Long count = (Long) session.createQuery("select count(*) from Article").uniqueResult();
            tx.commit();
            return count.toString();
        } catch (Exception e) {
            if (tx != null) {
                tx.rollback();
            }
            e.printStackTrace();
            throw e;
        }
    }

    public String getArticleTitle(Long page) {
        Transaction tx = null;
        Session session = HibernateUtil.getSessionFactory().getCurrentSession();
        try {
            tx = session.beginTransaction();
            CriteriaBuilder builder = session.getCriteriaBuilder();
            CriteriaQuery<Article> criteria = builder.createQuery(Article.class);
            criteria.from(Article.class);
            List<Article> data = session.createQuery(criteria).getResultList();
            String title = data.get(page.intValue() - 1).getTitle();
            tx.commit();
            return title;
        } catch (Exception e) {
            if (tx != null) {
                tx.rollback();
            }
            e.printStackTrace();
            throw e;
        }
    }

    public String getArticleContent(Long page) {
        Transaction tx = null;
        Session session = HibernateUtil.getSessionFactory().getCurrentSession();
        try {
            tx = session.beginTransaction();
            CriteriaBuilder builder = session.getCriteriaBuilder();
            CriteriaQuery<Article> criteria = builder.createQuery(Article.class);
            criteria.from(Article.class);
            List<Article> data = session.createQuery(criteria).getResultList();
            String content = data.get(page.intValue() - 1).getContent();
            tx.commit();
            return content;
        } catch (Exception e) {
            if (tx != null) {
                tx.rollback();
            }
            e.printStackTrace();
            throw e;
        }
    }

    public String create(String title, String content) {
        Transaction tx = null;
        Session session = HibernateUtil.getSessionFactory().getCurrentSession();
        try {
            tx = session.beginTransaction();
            Article article = new Article();
            article.setTitle(title);
            article.setContent(content);

            session.save(article);
            tx.commit();
            return "User subscribed successfully";
        } catch (Exception e) {
            if (tx != null) {
                tx.rollback();
            }
            e.printStackTrace();
            throw e;
        }
    }
}
