package edujin.service;

import edujin.repository.PasswordResetTokenRepository;

import javax.jws.HandlerChain;
import javax.jws.WebMethod;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.xml.soap.SOAPException;

@WebService
@SOAPBinding(style = SOAPBinding.Style.DOCUMENT)
public class ResetPasswordService extends BaseWebService {

    @WebMethod
    public String sendEmail(String userId, String userEmail) {
        try {
            return PasswordResetTokenRepository.getInstance().create(userId, userEmail);
        } catch (Exception e) {
            e.printStackTrace();
            return e.toString();
        }
    }
    @WebMethod
    public String validateToken(String userId, String token) {
        try {
            return PasswordResetTokenRepository.getInstance().validateToken(userId, token);
        } catch (Exception e) {
            e.printStackTrace();
            return e.toString();
        }
    }

    @WebMethod
    public String deleteToken(String userId) {
        try {
            PasswordResetTokenRepository.getInstance().delete(userId);
            return "200";
        } catch (Exception e) {
            e.printStackTrace();
            return e.toString();
        }
    }
}

